package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.examination.ExaminableProperty;

public interface NBTComponent<C extends NBTComponent<C, B>, B extends NBTComponentBuilder<C, B>> extends BuildableComponent<C, B> {
   @NotNull String nbtPath();

   @Contract(
      pure = true
   )
   @NotNull C nbtPath(final @NotNull String nbtPath);

   boolean interpret();

   @Contract(
      pure = true
   )
   @NotNull C interpret(final boolean interpret);

   @Nullable Component separator();

   @NotNull C separator(final @Nullable ComponentLike separator);

   default @NotNull Stream<? extends ExaminableProperty> examinableProperties() {
      return Stream.concat(Stream.of(ExaminableProperty.of("nbtPath", this.nbtPath()), ExaminableProperty.of("interpret", this.interpret()), ExaminableProperty.of("separator", this.separator())), BuildableComponent.super.examinableProperties());
   }
}
